Bug 570166 - Review Request: rstp - user space rapid spanning tree protocol daemon
Summary: Review Request: rstp - user space rapid spanning tree protocol daemon
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Gwyn Ciesla
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 555400
TreeView+ depends on / blocked
 
Reported: 2010-03-03 14:17 UTC by Neil Horman
Modified: 2010-04-09 03:53 UTC (History)
5 users (show)

Fixed In Version: rstp-04012009git-4.fc13
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2010-04-09 03:53:02 UTC
gwync: fedora-review+
kevin: fedora-cvs+


Attachments (Terms of Use)

Description Neil Horman 2010-03-03 14:17:14 UTC
Spec URL: http://people.redhat.com/nhorman/rpms/rstp.spec
SRPM URL: http://people.redhat.com/nhorman/rpms/rstp-04012009git-1.fc12.src.rpm
Description: rstp is a user space based spanning tree protocol daemon, that is meant to take over the spanning tree protocol work that normally happens in the kernel.

Comment 1 Gwyn Ciesla 2010-04-07 14:33:49 UTC
#  MUST: rpmlint must be run on every package. The output should be posted in the review.[1]

rstp.src: W: invalid-url URL git://git.kernel.org/pub/scm/linux/kernel/git/shemminger/rstp.git
The value should be a valid, public HTTP, HTTPS, or FTP URL.

rstp.src: W: invalid-url Source0: rstp-04012009git.tar.bz2
The value should be a valid, public HTTP, HTTPS, or FTP URL.

1 packages and 0 specfiles checked; 0 errors, 2 warnings.

[limb@bamboo SPECS]$ rpmlint -i ../RPMS/i686/rstp-*
rstp.i686: W: invalid-url URL git://git.kernel.org/pub/scm/linux/kernel/git/shemminger/rstp.git
The value should be a valid, public HTTP, HTTPS, or FTP URL.

rstp-debuginfo.i686: W: invalid-url URL git://git.kernel.org/pub/scm/linux/kernel/git/shemminger/rstp.git
The value should be a valid, public HTTP, HTTPS, or FTP URL.

2 packages and 0 specfiles checked; 0 errors, 2 warnings.


FIX   URL tag is for the website for the project.  The source error is OK since this is a git snapshot.

# MUST: The package must be named according to the Package Naming Guidelines .

OK.

# MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption. [2] .

OK

# MUST: The package must meet the Packaging Guidelines .

OK.  Should this have an initscript, though?  I don't know, I've not used this.

# MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .

OK.

# MUST: The License field in the package spec file must match the actual license. [3]

OK.

# MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.[4]

FIX.  Also include the CHANGES_TO_RSTPLIB and TODO, and the rstplib docs, in %doc.

# MUST: The spec file must be written in American English. [5]

OK.

# MUST: The spec file for the package MUST be legible. [6]

OK.

# MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.

OK.  Git checkout.

# MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture. [7]

OK.

# MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line. [8]

OK.

# MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.

Mock build in progress to check this.

# MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.[9]

OK.

# MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. [10]

N/A.

# MUST: Packages must NOT bundle copies of system libraries.[11]

OK.

# MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker. [12]

OK.

# MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. [13]

OK.

# MUST: A Fedora package must not list a file more than once in the spec file's %files listings. [14]

OK.

# MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line. [15]

OK.

# MUST: Each package must consistently use macros. [16]

FIX.  You use one macro style for cflags, the other for buildroot.  Pick one.
https://fedoraproject.org/wiki/Packaging/Guidelines#macros

# MUST: The package must contain code, or permissable content. [17]

OK.

# MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity). [18]

N/A.

# MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present. [18]

OK.

# MUST: Header files must be in a -devel package. [19]

N/A.

# MUST: Static libraries must be in a -static package. [20]

N/A.

# MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package. [19]

N/A.

# MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release} [21]

N/A.

# MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.[20]

OK.

# MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation. [22]

OK.

# MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time. [23]

OK.

# MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} (or $RPM_BUILD_ROOT). [24]

OK.
# MUST: All filenames in rpm packages must be valid UTF-8. [25]

OK.



So we're OK, expect for the URL tag, docs, and macros, and the ourstanding BuildRequires check.

Comment 2 Jonathan Underwood 2010-04-07 15:10:19 UTC
Some additional items:

1/ The patch should have a comment above it detailing it's upstream status.
See: 
http://fedoraproject.org/wiki/Packaging/Guidelines#All_patches_should_have_an_upstream_bug_link_or_comment

2/ It's advisable, when packaging a snapshot from an upstream VC system to include a comment in the spec file detailing how to generate the source tarball. See: http://fedoraproject.org/wiki/Packaging:SourceURL

Comment 3 Gwyn Ciesla 2010-04-07 15:18:52 UTC
+1 to Jonathan's comments, especially #2.  Good catch.

Also, the mock build was good, so the BuildRequires are as well.

Comment 4 Neil Horman 2010-04-07 15:39:46 UTC
Ok, just built in koji, and didn't get any BuildRequires errors, so I think we're good there.

New SPEC: http://people.redhat.com/nhorman/rpms/rstp.spec
New SRPM: http://people.redhat.com/nhorman/rpms/rstp-04012009git-2.fc12.src.rpm

I fixed up the %doc section as requested, removed the URL tag, since there is no project page, beyond the git tree, and removed the Buildroot tag to fix the macro issue (since its not required anymore, per https://fedoraproject.org/wiki/Packaging/Guidelines#BuildRoot_tag)

Thanks!

Comment 5 Neil Horman 2010-04-07 15:40:27 UTC
ugh, crossed in midair.  Gimmie a bit and I'll add those changes in.

Comment 6 Jonathan Underwood 2010-04-07 15:49:34 UTC
Another thing: you don't need to rm -rf $RPM_BUILD_ROOT in %install or %clean for F-13 upwards. This means it can be removed from %install, and the %clean section can be removed completely.

Comment 7 Neil Horman 2010-04-07 17:02:44 UTC
New SPEC: http://people.redhat.com/nhorman/rpms/rstp.spec
New SRPM: http://people.redhat.com/nhorman/rpms/rstp-04012009git-3.fc12.src.rpm

Ok, added comments, removed the clean script and the rm -rf from the install section.

Comment 8 Gwyn Ciesla 2010-04-07 17:16:07 UTC
Sorry, I forgot, you need to add LICENSE and rstplib/COPYING to doc.

Removing the buildroot, clean, and the line in install are only OK if you're not building for F-12 or earlier.  Keep this in mind.

rpmlint also yells about the lack of a URL tag.  If there's no project page, at least put a comment about this in the spec so people know why it's missing.

We're nearly there.

Comment 9 Neil Horman 2010-04-07 18:00:44 UTC
New SPEC: http://people.redhat.com/nhorman/rpms/rstp.spec
New SRPM: http://people.redhat.com/nhorman/rpms/rstp-04012009git-4.fc12.src.rpm

docs added, lack of url tag commented, buildroot concern noted.

Comment 10 Gwyn Ciesla 2010-04-07 18:39:43 UTC
APPROVED.

Hopefully someday there will be something to put in a URL tag. . .

Comment 11 Neil Horman 2010-04-07 18:45:03 UTC
not sure there will be, but fortunately this is a pretty straightforward little daemon.  Thanks for the review!

Comment 12 Neil Horman 2010-04-07 18:46:20 UTC
New Package CVS Request
=======================
Package Name: rstp
Short Description: user space rapid spanning tree daemon
Owners: nhorman
Branches: F-13
InitialCC:

Comment 13 Kevin Fenzi 2010-04-08 02:37:09 UTC
CVS done (by process-cvs-requests.py).

Comment 14 Chen Lei 2010-04-08 05:53:13 UTC


04012009git is not valid version number, 04012009git should add to the release field. Use 0 for version number or ask upstream for a version number.

Comment 15 Chen Lei 2010-04-08 05:54:48 UTC
not valid-> not a valid

See http://fedoraproject.org/wiki/Packaging:NamingGuidelines#Pre-Release_packages

Comment 16 Jonathan Underwood 2010-04-08 13:11:43 UTC
Yes, Chen Lei is technically correct - I had thought of mentioning this. However, that guidelines rests on the assumption that an upstream project actually makes releases, whereas it seems this project doesn't actually produce releases as such. Or hasn't to date. So I'm not sure if it's technically a pre-release or not. Some guideance from upstream might be needed here - asking the question "Do you plan to actually make releases" being the obvious question.

Comment 17 Neil Horman 2010-04-08 14:11:58 UTC
I can assue you that they'll not be making a release out of this anytime soon.  This project is functional, but really just serves to provide a user space option for spanning tree support should anyone want it.  Unless there is an upswell of user demand, there will be no official release.

Comment 18 Fedora Update System 2010-04-08 14:46:36 UTC
rstp-04012009git-4.fc13 has been submitted as an update for Fedora 13.
http://admin.fedoraproject.org/updates/rstp-04012009git-4.fc13

Comment 19 Fedora Update System 2010-04-09 03:52:58 UTC
rstp-04012009git-4.fc13 has been pushed to the Fedora 13 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.